// CDXTileBase.cpp: implementation of the CDXTileBase class.
//
//////////////////////////////////////////////////////////////////////

#include "CDXTileBase.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDXTileBase::CDXTileBase()
{
	m_InternalFlags = 0;
	m_Data = 0;
}

CDXTileBase::~CDXTileBase()
{
	if (m_Data)
		delete[] m_Data;
}

void CDXTileBase::CreateData(DWORD count)
{
	if (m_Data)
		delete[] m_Data;
	m_Data = new DWORD[count];

#ifdef _DEBUG
	m_DataCount = count;
#endif
}

void CDXTileBase::SetData(DWORD index, DWORD data)
{
	Assert(index < m_DataCount, "CDXTileBase::SetData\nindex>=m_DataCount");
	m_Data[index] = data;
}

DWORD CDXTileBase::GetData(DWORD index)
{
	Assert(index < m_DataCount, "CDXTileBase::GetData\nindex of out range");
	return m_Data[index];
}

DWORD CDXTileBase::GetFlag(DWORD flagBits)
{
	return (m_InternalFlags & flagBits);
}

void CDXTileBase::SetFlag(DWORD flagBits, BOOL set)
{
	if (set)
		m_InternalFlags |= flagBits;
	else
		m_InternalFlags &= ~flagBits;
}

