// CDXTileBase.h: interface for the CDXTileBase class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CDXTILEBASE_H__DE30C3E1_01C4_11D0_A2B6_9C449FB7024B__INCLUDED_)
#define AFX_CDXTILEBASE_H__DE30C3E1_01C4_11D0_A2B6_9C449FB7024B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "CTE.h"

// For Debugging Purpose
#ifdef _DEBUG													

	#define Assert(booleanExpression, errorMessage)					\
		if (!(booleanExpression))									\
		{															\
			::MessageBox(0, errorMessage, "CDXTile Error", MB_OK);	\
			ASSERT(booleanExpression);								\
		}

	#define Assert2(booleanExpression, errorMsg1, errorMsg2)		\
	if (!(booleanExpression))										\
	{																\
		char assertTemp[1000];										\
		strcpy(assertTemp, errorMsg1);								\
		strcat(assertTemp, "\n");									\
		strcat(assertTemp, errorMsg2);								\
			::MessageBox(0, assertTemp, "CDXTile Error", MB_OK);	\
		ASSERT(booleanExpression);									\
	}																

#else

	#define Assert(booleanExpression, errorMessage)
	#define Assert2(booleanExpression, errorMsg1, errorMsg2)

#endif



class CDXTileBase  
{
public:
	void SetFlag(DWORD flagBits, BOOL set = TRUE);
	// return non zero if at least one of flagBits are set
	DWORD GetFlag(DWORD flagBits);
	DWORD GetData(DWORD index);
	void SetData(DWORD index, DWORD data);
	void CreateData(DWORD count);
	CDXTileBase();
	virtual ~CDXTileBase();

protected:
	DWORD m_InternalFlags;	   // internal flags, don't modified directly
	DWORD* m_Data;			   // user defined data

#ifdef _DEBUG	
	DWORD m_DataCount;		   // number of user define data
#endif
};

#endif // !defined(AFX_CDXTILEBASE_H__DE30C3E1_01C4_11D0_A2B6_9C449FB7024B__INCLUDED_)
