// CDXTileEngine.h: interface for the CDXTileEngine class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CDXTILEENGINE_H__38C8C781_FCBB_11CF_A2B6_9AB547EC654B__INCLUDED_)
#define AFX_CDXTILEENGINE_H__38C8C781_FCBB_11CF_A2B6_9AB547EC654B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "CDXTileBase.h"
#include "CDXTileManager.h"
#include "CDXTileViewer.h"

class CDXTileUnit;
class CDXTileAnim;
class CDXTileLayer;
//class CDXTileViewer;
//class CDXTileManager;

class CDXTileEngine : public CDXTileManager
{
// I used friend just for temporary, I will change it later
friend void CDXTileViewer::Draw(CDXTileEngine*);
//friend CDXTileEngine* CDXTileManager::Register(char* name, CDXTileEngine*);

public :
	enum {LAST_LAYER = -1, NEW_LAYER = -2};

public:
	void RandomAnim();
	void DeleteLayer(int layerIndex);
	int FindLayer(CDXTileLayer* pLayer);
	void UpdateAnim();
	CDXTileAnim* CreateTileAnim(CDXSprite* tileSpr, int height, WORD bltType = CDXBLT_TRANS);
	CDXTileUnit* CreateTileUnit(CDXSprite* tileSpr, int frame, int height, WORD bltType = CDXBLT_TRANS);
	CDXTileStack* CreateTileStack();
	CDXTileManager* GetManager();
	void SetLayer(CDXTileLayer* pLayer, int layerIndex = NEW_LAYER);
	void ScrollMap(int distPosX, int distPosY);
	CDXTileViewer* GetViewer();
	CDXTileViewer* SetViewer(CDXTileViewer* pViewer);
	void GetMapPos(int* x, int* y);
	CDXTileLayer* GetLayer(int index);
	int GetLayerCount();

	void Draw();
	BOOL LoadFile(char* filename);
	BOOL SaveFile(char* filename);

	CDXTileLayer* CreateLayer(int mapDimX, int mapDimY, int tileSizeX, int tileSizeY, int layerIndex = NEW_LAYER);
	void SetMapPos(int x, int y);
	CDXTileEngine();
	virtual ~CDXTileEngine();

// advance
	void SetULPos(int x, int y);


protected:
	void Init();
	int m_PosX, m_PosY;		   // current UL map position in pixel
	CPtrArray m_Layers;		   // array of layer (CDXTileLayer)
	CDXTileViewer* m_pViewer;  // default viewer
	//CDXTileManager m_Manager;
};

#endif // !defined(AFX_CDXTILEENGINE_H__38C8C781_FCBB_11CF_A2B6_9AB547EC654B__INCLUDED_)
