// CDXTileSprite.cpp: implementation of the CDXTileSprite class.
//
//////////////////////////////////////////////////////////////////////

#include "CDXTileSprite.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDXTileSprite::CDXTileSprite(
	CDXScreen* pScreen, const char* Filename, int w, int h, int num, BOOL memoryType,
	CDXTileLayer* pLayer, int posX, int posY)
	: CDXSprite(pScreen, Filename, w, h, num, memoryType),
	  CDXTileSpriteBase(pLayer, posX, posY)
{
	CDXSprite::SetPos(posX, posY);
}

CDXTileSprite::CDXTileSprite(
	CDXTile* pTile, 
	CDXTileLayer* pLayer, int posX, int posY)
	: CDXSprite(pTile),
	  CDXTileSpriteBase(pLayer, posX, posY)
{
	CDXSprite::SetPos(posX, posY);
}

CDXTileSprite::CDXTileSprite(CDXTileLayer* pLayer, int posX, int posY)
	: CDXTileSpriteBase(pLayer, posX, posY)
{
	CDXSprite::SetPos(posX, posY);
}

CDXTileSprite::CDXTileSprite(CDXTileLayer* pLayer)
	: CDXTileSpriteBase(pLayer)
{
	CDXSprite::SetPos(0, 0);
}

CDXTileSprite::CDXTileSprite()
{

}

CDXTileSprite::~CDXTileSprite()
{

}

void CDXTileSprite::SetPos(int posX, int posY)
{
	CDXSprite::SetPos(posX, posY);
	CDXTileSpriteBase::SetPos(posX, posY);
}

void CDXTileSprite::OnDraw(CDXSurface* targetSurface, int screenX, int screenY)
{	
	int oldPosX = m_PosX; 
	int oldPosY = m_PosY;
	CDXSprite::SetPos(screenX, screenY-48);
	Draw(targetSurface, 0, 0, CDXBLT_TRANS);
	CDXSprite::SetPos(oldPosX, oldPosY);
}
