// CDXTileSpriteBase.cpp: implementation of the CDXTileSpriteBase class.
//
//////////////////////////////////////////////////////////////////////

#include "CDXTileSpriteBase.h"
#include "CDXTileLayer.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDXTileSpriteBase::CDXTileSpriteBase(CDXTileLayer* pLayer, int posX, int posY)
{
	Init();
	m_pLayer = pLayer;
	SetPos(posX, posY);
}

CDXTileSpriteBase::CDXTileSpriteBase(CDXTileLayer* pLayer)
{
	Init();
	SetLayer(pLayer);
}

CDXTileSpriteBase::CDXTileSpriteBase()
{
	Init();
}

CDXTileSpriteBase::~CDXTileSpriteBase()
{

}

void CDXTileSpriteBase::SetPos(int posX, int posY)
{
	Assert(m_pLayer, "CDXTileSpriteBase::SetPos\nNo Layer");
	int newCoordX, newCoordY;
	m_pLayer->PosToCoord(posX, posY, newCoordX, newCoordY);
	if (m_CoordX != newCoordX || m_CoordY != newCoordY)
	{
		m_pLayer->UpdateSprite(this, m_CoordX, m_CoordY, m_Index, newCoordX, newCoordY);
		m_CoordX = newCoordX; m_CoordY = newCoordY;
	}
	m_PX = posX; m_PY = posY;
}

void CDXTileSpriteBase::Init()
{
	m_CoordX = -1; m_CoordY = -1;
	m_PX = -1; m_PY = -1;
	m_Index = -1;
	m_pLayer = 0;
}

void CDXTileSpriteBase::SetLayer(CDXTileLayer *pLayer)
{
	m_pLayer = pLayer;
	SetPos(0, 0);
}


int CDXTileSpriteBase::GetPosX()
{
	return m_PX;
}

int CDXTileSpriteBase::GetPosY()
{
	return m_PY;
}
