// CDXTileStack.cpp: implementation of the CDXTileStack class.
//
//////////////////////////////////////////////////////////////////////

#include "CDXTileStack.h"
#include "CDXTileUnit.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDXTileStack::CDXTileStack()
{

}

CDXTileStack::~CDXTileStack()
{

}

CDXTileUnit* CDXTileStack::GetTile(int index)
{
	Assert(index < GetTileCount(), "CDXTileStack::GetTile\nIndex out of range");
	return (CDXTileUnit*)m_Tiles[index];
}

void CDXTileStack::AddTile(CDXTileUnit *tile)
{
	for (int index = m_Tiles.GetUpperBound(); index>=0; index--)
		if (GetTile(index)->GetHeight() <= tile->GetHeight())
		{
			m_Tiles.InsertAt(index+1, tile);
			return;
		}
	m_Tiles.Add(tile);
}

void CDXTileStack::Draw(CDXSurface *targetSurface, int screenX, int screenY)
{
	int count = GetTileCount();
	for (int i=0; i<count; i++)
		GetTile(i)->Draw(targetSurface, screenX, screenY);
}

int CDXTileStack::GetTileCount()
{
	return m_Tiles.GetSize();
}
