// CDXTileUnit.cpp: implementation of the CDXTileUnit class.
//
//////////////////////////////////////////////////////////////////////

#include "CDXTileUnit.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDXTileUnit::CDXTileUnit(CDXSprite* tileSpr, int frame, int height, WORD bltType)
{
	Init();
	Set(tileSpr, height, bltType);
	SetFrame(frame);
}

CDXTileUnit::CDXTileUnit()
{
	Init();
}

CDXTileUnit::~CDXTileUnit()
{
}

void CDXTileUnit::Set(CDXSprite* tileSpr, int height, WORD bltType)
{
	SetTile(tileSpr);
	SetHeight(height);
	SetBltType(bltType);
}

void CDXTileUnit::Draw(CDXSurface *targetSurface, int screenX, int screenY)
{
	Assert(m_TileSpr,"CDXTileUnit::Draw\nNo CDXSprite");

	/*RECT srcRect;

	if (GetFlag(BIT_UNITCAP_OPTIMIZE_SPEED))
	{
		srcRect = *m_SrcRect;
	} else
	{
		// This code are taken from CDXSprite
		// Get the number of tiles in the sprite tile surface width
		WORD TilesInWidth = m_Tile->m_PixelWidth / m_Tile->m_BlockWidth;

		// Calc the upper left corner of the current frame of animation
		DWORD SpriteSrcX = m_Frame % TilesInWidth * m_Tile->m_BlockWidth;
		DWORD SpriteSrcY = m_Frame / TilesInWidth * m_Tile->m_BlockHeight;
		
		// Define the source RECT for the BLT.
		srcRect.top = SpriteSrcY;
		srcRect.left = SpriteSrcX;
		srcRect.bottom = SpriteSrcY + m_Tile->m_BlockHeight;
		srcRect.right = SpriteSrcX + m_Tile->m_BlockWidth;
	}*/

	/*HRESULT rval = */
	/*m_Tile->CDXBLT_Trans(targetSurface, 
				screenX, 
				screenY-m_Tile->m_BlockHeight-m_Height, 
				srcRect); */
	m_TileSpr->SetFrame(m_Frame);
	m_TileSpr->SetPos(
		screenX+m_DrawOffX, 
		screenY+m_DrawOffY-m_TileSpr->m_Tile->m_BlockHeight-m_Height);
	m_TileSpr->Draw(targetSurface, 0, 0,
				m_BltType);
	

	//return rval;
}

void CDXTileUnit::SetFrame(int frame)
{
	m_Frame = frame;

	/*// Precalculate the Source Rect
	if (GetFlag(BIT_UNITCAP_OPTIMIZE_SPEED))
	{

		// This code are taken from CDXSprite
		// Get the number of tiles in the sprite tile surface width
		WORD TilesInWidth = m_Tile->m_PixelWidth / m_Tile->m_BlockWidth;

		// Calc the upper left corner of the current frame of animation
		DWORD SpriteSrcX = m_Frame % TilesInWidth * m_Tile->m_BlockWidth;
		DWORD SpriteSrcY = m_Frame / TilesInWidth * m_Tile->m_BlockHeight;
		
		// Define the source RECT for the BLT.
		m_SrcRect->top = SpriteSrcY;
		m_SrcRect->left = SpriteSrcX;
		m_SrcRect->bottom = SpriteSrcY + m_Tile->m_BlockHeight;
		m_SrcRect->right = SpriteSrcX + m_Tile->m_BlockWidth;
	}*/
}

void CDXTileUnit::UpdateAnim()
{
	// nothing todo
	// this class doesn't have animated frame
}

void CDXTileUnit::SetCapabilities(DWORD capabilities)
{
	/*SetFlag(BIT_UNITCAP_OPTIMIZE_SPEED, capabilities & CAP_OPTIMIZE_SPEED);
	InitOptimizeSpeed();*/
}

BOOL CDXTileUnit::GetCapabilities(DWORD capabilities)
{
/*	if (capabilities & CAP_OPTIMIZE_SPEED && !GetFlag(BIT_UNITCAP_OPTIMIZE_SPEED))
		return false;*/
	return true;
}

void CDXTileUnit::SetCapability(DWORD capability, BOOL set)
{
/*	if (capability == CAP_OPTIMIZE_SPEED)
	{
		SetFlag(BIT_UNITCAP_OPTIMIZE_SPEED, set); 
		InitOptimizeSpeed();
	}		*/
}

void CDXTileUnit::Init()
{
	m_SrcRect = 0;
	Set(NULL, 0, FALSE);
	m_Frame = 0;
	m_BltType = CDXBLT_TRANS;
	SetDrawingOffset(0,0);
	//SetCapability(CAP_OPTIMIZE_SPEED);
}

/*void CDXTileUnit::InitOptimizeSpeed()
{
	if (GetFlag(BIT_UNITCAP_OPTIMIZE_SPEED))
	{
		if (m_SrcRect == 0)
			m_SrcRect = new RECT;
	} else
	{
		if (m_SrcRect)
			delete m_SrcRect;
		m_SrcRect = 0;
	}
	SetFrame(m_Frame);
}*/

void CDXTileUnit::SetBltType(WORD bltType)
{
	m_BltType = bltType;
}

void CDXTileUnit::SetTile(CDXSprite *tileSpr)
{
	m_TileSpr = tileSpr;
}

void CDXTileUnit::SetHeight(int height)
{
	m_Height = height;
}

int CDXTileUnit::GetHeight()
{
	return m_Height;
}

WORD CDXTileUnit::GetBltType()
{
	return m_BltType;
}

CDXSprite* CDXTileUnit::GetTile()
{
	return m_TileSpr;
}

void CDXTileUnit::SetDrawingOffset(int offsetX, int offsetY)
{
	m_DrawOffX = offsetX;
	m_DrawOffY = offsetY;
}

void CDXTileUnit::GetDrawingOffset(int &offsetX, int &offsetY)
{
	offsetX = m_DrawOffX;
	offsetY = m_DrawOffY;
}

int CDXTileUnit::CalculateDrawingOffsetY(int tileSizeY, WORD UnitOffY, WORD TileOffY)
{
	// tileSizeY is the tileSizeY of Layer
	// UnitOffY if the offset/point in the TileUnit 
	// to match with the offset/point in the Tile which is
	// pointed by TileOffY

	int offsetY = 0;

	if (UnitOffY == OFFY_CENTER)
		offsetY += m_TileSpr->m_Tile->m_BlockHeight/2; else
	if (UnitOffY == OFFY_TOP)
		offsetY += m_TileSpr->m_Tile->m_BlockHeight;

	if (TileOffY == OFFY_CENTER)
		offsetY -= tileSizeY/2; else
	if (TileOffY == OFFY_TOP)
		offsetY -= tileSizeY;
	
	return offsetY;
}

int CDXTileUnit::CalculateDrawingOffsetX(int tilesizeX, WORD UnitOffX, WORD TileOffX)
{
	// tilesizeX is the tilesizeX of Layer
	// UnitOffX if the offset/point in the TileUnit 
	// to match with the offset/point in the Tile which is
	// pointed by TileOffX

	int offsetX = 0;

	if (UnitOffX == OFFX_CENTER)
		offsetX -= m_TileSpr->m_Tile->m_BlockWidth/2; else
	if (UnitOffX == OFFX_RIGHT)
		offsetX -= m_TileSpr->m_Tile->m_BlockWidth;

	if (TileOffX == OFFX_CENTER)
		offsetX += tilesizeX/2; else
	if (TileOffX == OFFX_RIGHT)
		offsetX += tilesizeX;
	
	return offsetX;
}
