// CDXTileUnit.h: interface for the CDXTileUnit class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CDXTILEUNIT_H__38C8C785_FCBB_11CF_A2B6_9AB547EC654B__INCLUDED_)
#define AFX_CDXTILEUNIT_H__38C8C785_FCBB_11CF_A2B6_9AB547EC654B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "CDXTileManager.h"

class CDXTileUnit : public CDXTileBase
{
friend CDXTileUnit* CDXTileManager::Register(const char* name, CDXTileUnit*);

public:
	// for Drawing Offset X Type
	enum {OFFX_NONE, OFFX_LEFT, OFFX_CENTER, OFFX_RIGHT};

	// for Drawing Offset Y Type
	enum {OFFY_NONE, OFFY_BOTTOM, OFFY_CENTER, OFFY_TOP};

	int CalculateDrawingOffsetY(
		int tileSizeY, 
		WORD UnitOffY, WORD TileOffY);
	int CalculateDrawingOffsetX(
		int tilesizeX, 
		WORD UnitOffX, WORD TileOffX);
	void GetDrawingOffset(int& offsetX, int& offsetY);
	void SetDrawingOffset(int offsetX, int offsetY);
	CDXSprite* GetTile();
	WORD GetBltType();
	int GetHeight();
	void SetHeight(int height);
	void SetTile(CDXSprite* tileSpr);
	void SetBltType(WORD bltType);
	void Init();
	void SetCapability(DWORD capability, BOOL set = TRUE);
	BOOL GetCapabilities(DWORD capabilities);
	void SetCapabilities(DWORD capabilities);
	virtual void UpdateAnim();
	void SetFrame(int frame);
	virtual void Draw(CDXSurface* targetSurface, int screenX, int screenY);
	void Set(CDXSprite* tileSpr, int height, WORD bltType = CDXBLT_TRANS);
	CDXTileUnit();
	CDXTileUnit(CDXSprite* tileSpr, int frame, int height, WORD bltType = CDXBLT_TRANS);
	virtual ~CDXTileUnit();

protected:
	int m_Frame;
	CDXSprite* m_TileSpr;
	int m_Height;
	WORD m_BltType;
	RECT* m_SrcRect;
	int m_DrawOffX, m_DrawOffY;	// Offset for Tile Drawing
};

#endif // !defined(AFX_CDXTILEUNIT_H__38C8C785_FCBB_11CF_A2B6_9AB547EC654B__INCLUDED_)
