// CDXTileViewer.h: interface for the CDXTileViewer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CDXTILEVIEWER_H__3DD28F45_FCC5_11CF_A2B6_82A0EDBA634B__INCLUDED_)
#define AFX_CDXTILEVIEWER_H__3DD28F45_FCC5_11CF_A2B6_82A0EDBA634B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "CDXTileBase.h"
#include "CDXTileManager.h"

class CDXTileEngine;
class CDXTileLayer;

class CDXTileViewer : public CDXTileBase
{
friend CDXTileViewer* CDXTileManager::Register(const char* name, CDXTileViewer*);
public:
	BOOL GetViewRect(RECT& viewRect);
	void SetViewRect(RECT viewRect);
	void SetWrapView(BOOL bWrap);
	void SetSurface(CDXSurface* pSurface);
	void Draw(CDXTileEngine* pEngine);
	virtual void Draw(CDXTileLayer* pLayer) = 0;
	CDXTileViewer();
	CDXTileViewer(CDXSurface* pSurface);
	virtual ~CDXTileViewer();
protected:
	RECT* m_ViewRect;
	CDXSurface* m_pSurface;
private:
	void Init();
};

#endif // !defined(AFX_CDXTILEVIEWER_H__3DD28F45_FCC5_11CF_A2B6_82A0EDBA634B__INCLUDED_)
